diff --git a/hw/xquartz/quartzKeyboard.c b/hw/xquartz/quartzKeyboard.c
index c35a2d15d..d2b7f422f 100644
--- a/hw/xquartz/quartzKeyboard.c
+++ b/hw/xquartz/quartzKeyboard.c
@@ -46,6 +46,7 @@
 #include <stdlib.h>
 #include <errno.h>
 #include <sys/stat.h>
+#include <AvailabilityMacros.h>
 
 #include "quartz.h"
 #include "darwin.h"
@@ -732,6 +733,65 @@ DarwinModifierStringToNXMask(const char *str, int separatelr)
     return 0;
 }
 
+/*
+ * LegalModifier
+ *      This allows the ddx layer to prevent some keys from being remapped
+ *      as modifier keys.
+ */
+Bool
+LegalModifier(unsigned int key, DeviceIntPtr pDev)
+{
+    return 1;
+}
+
+#if !defined(__LP64__) || MAC_OS_X_VERSION_MIN_REQUIRED < 1050
+static inline UniChar
+macroman2ucs(unsigned char c)
+{
+    /* Precalculated table mapping MacRoman-128 to Unicode. Generated
+       by creating single element CFStringRefs then extracting the
+       first character. */
+
+    static const unsigned short table[128] = {
+        0xc4,   0xc5,     0xc7,       0xc9,       0xd1,       0xd6,       0xdc,
+        0xe1,
+        0xe0,   0xe2,     0xe4,     0xe3,     0xe5,   0xe7,     0xe9,
+        0xe8,
+        0xea,   0xeb,     0xed,     0xec,     0xee,   0xef,     0xf1,
+        0xf3,
+        0xf2,   0xf4,     0xf6,     0xf5,     0xfa,   0xf9,     0xfb,
+        0xfc,
+        0x2020, 0xb0,     0xa2,     0xa3,     0xa7,   0x2022,   0xb6,
+        0xdf,
+        0xae,   0xa9,     0x2122,   0xb4,     0xa8,   0x2260,   0xc6,
+        0xd8,
+        0x221e, 0xb1,     0x2264,   0x2265,   0xa5,   0xb5,     0x2202,
+        0x2211,
+        0x220f, 0x3c0,    0x222b,   0xaa,     0xba,   0x3a9,    0xe6,
+        0xf8,
+        0xbf,   0xa1,     0xac,     0x221a,   0x192,  0x2248,   0x2206,
+        0xab,
+        0xbb,   0x2026,   0xa0,     0xc0,     0xc3,   0xd5,     0x152,
+        0x153,
+        0x2013, 0x2014,   0x201c,   0x201d,   0x2018, 0x2019,   0xf7,
+        0x25ca,
+        0xff,   0x178,    0x2044,   0x20ac,   0x2039, 0x203a,   0xfb01,
+        0xfb02,
+        0x2021, 0xb7,     0x201a,   0x201e,   0x2030, 0xc2,     0xca,
+        0xc1,
+        0xcb,   0xc8,     0xcd,     0xce,     0xcf,   0xcc,     0xd3,
+        0xd4,
+        0xf8ff, 0xd2,     0xda,     0xdb,     0xd9,   0x131,    0x2c6,
+        0x2dc,
+        0xaf,   0x2d8,    0x2d9,    0x2da,    0xb8,   0x2dd,    0x2db,
+        0x2c7,
+    };
+
+    if (c < 128) return c;
+    else return table[c - 128];
+}
+#endif
+
 static KeySym
 make_dead_key(KeySym in)
 {
@@ -746,34 +806,83 @@ make_dead_key(KeySym in)
 static Bool
 QuartzReadSystemKeymap(darwinKeyboardInfo *info)
 {
-    __block const void *chr_data = NULL;
+#if !defined(__LP64__) || MAC_OS_X_VERSION_MIN_REQUIRED < 1050
+    KeyboardLayoutRef key_layout;
+    int is_uchr = 1;
+#endif
+    const void *chr_data = NULL;
     int num_keycodes = NUM_KEYCODES;
-    __block UInt32 keyboard_type;
+    UInt32 keyboard_type = LMGetKbdType();
     int i, j;
     OSStatus err;
     KeySym *k;
+    CFDataRef currentKeyLayoutDataRef = NULL;
 
-    dispatch_block_t getKeyboardData = ^{
-        keyboard_type = LMGetKbdType();
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+    TISInputSourceRef currentKeyLayoutRef =
+        TISCopyCurrentKeyboardLayoutInputSource();
 
-        TISInputSourceRef currentKeyLayoutRef = TISCopyCurrentKeyboardLayoutInputSource();
+    if (currentKeyLayoutRef) {
+        currentKeyLayoutDataRef = (CFDataRef)TISGetInputSourceProperty(
+            currentKeyLayoutRef, kTISPropertyUnicodeKeyLayoutData);
+        if (currentKeyLayoutDataRef)
+            chr_data = CFDataGetBytePtr(currentKeyLayoutDataRef);
+    }
+#endif
+
+#ifdef __clang__
+#pragma clang diagnostic push
+#pragma clang diagnostic ignored "-Wdeprecated-declarations" // KLGetCurrentKeyboardLayout, KLGetKeyboardLayoutProperty
+#endif
+
+#if !defined(__LP64__) || MAC_OS_X_VERSION_MIN_REQUIRED < 1050
+    if (chr_data == NULL) {
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+        ErrorF(
+            "X11.app: Error detected in determining keyboard layout.  If you are using an Apple-provided keyboard layout, please report this error at http://xquartz.macosforge.org and http://bugreport.apple.com\n");
+        ErrorF(
+            "X11.app: Debug Info: keyboard_type=%u, currentKeyLayoutRef=%p, currentKeyLayoutDataRef=%p, chr_data=%p\n",
+            (unsigned)keyboard_type, currentKeyLayoutRef,
+            currentKeyLayoutDataRef, chr_data);
+#endif
 
-        if (currentKeyLayoutRef) {
-            CFDataRef currentKeyLayoutDataRef = (CFDataRef)TISGetInputSourceProperty(currentKeyLayoutRef,
-                                                                                     kTISPropertyUnicodeKeyLayoutData);
-            if (currentKeyLayoutDataRef)
-                chr_data = CFDataGetBytePtr(currentKeyLayoutDataRef);
+        KLGetCurrentKeyboardLayout(&key_layout);
+        KLGetKeyboardLayoutProperty(key_layout, kKLuchrData, &chr_data);
 
-            CFRelease(currentKeyLayoutRef);
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+        if (chr_data != NULL) {
+            ErrorF(
+                "X11.app: Fallback succeeded, but this is still a bug.  Please report the above information.\n");
         }
-    };
+#endif
+    }
 
-    /* This is an ugly ant-pattern, but it is more expedient to address the problem right now. */
-    if (pthread_main_np()) {
-        getKeyboardData();
-    } else {
-        dispatch_sync(dispatch_get_main_queue(), getKeyboardData);
+    if (chr_data == NULL) {
+        ErrorF(
+            "X11.app: Debug Info: kKLuchrData failed, trying kKLKCHRData.\n");
+        ErrorF(
+            "If you are using a 3rd party keyboard layout, please see http://xquartz.macosforge.org/trac/ticket/154\n");
+        KLGetKeyboardLayoutProperty(key_layout, kKLKCHRData, &chr_data);
+        is_uchr = 0;
+        num_keycodes = 128;
+
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+        if (chr_data != NULL) {
+            ErrorF(
+                "X11.app: Fallback succeeded, but this is still a bug.  Please report the above information.\n");
+        }
+#endif
     }
+#endif
+
+#ifdef __clang__
+#pragma clang diagnostic pop
+#endif
+
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+    if (currentKeyLayoutRef)
+        CFRelease(currentKeyLayoutRef);
+#endif
 
     if (chr_data == NULL) {
         ErrorF("Couldn't get uchr or kchr resource\n");
@@ -797,6 +906,9 @@ QuartzReadSystemKeymap(darwinKeyboardInfo *info)
         k = info->keyMap + i * GLYPHS_PER_KEY;
 
         for (j = 0; j < 4; j++) {
+#if !defined(__LP64__) || MAC_OS_X_VERSION_MIN_REQUIRED < 1050
+            if (is_uchr) {
+#endif
             UniChar s[8];
             UniCharCount len;
             UInt32 dead_key_state = 0, extra_dead = 0;
@@ -823,6 +935,42 @@ QuartzReadSystemKeymap(darwinKeyboardInfo *info)
                 k[j] = ucs2keysym(s[0]);
                 if (dead_key_state != 0) k[j] = make_dead_key(k[j]);
             }
+#if !defined(__LP64__) || MAC_OS_X_VERSION_MIN_REQUIRED < 1050
+        }
+        else {       // kchr
+            UInt32 c, state = 0, state2 = 0;
+            UInt16 code;
+
+            code = i | mods[j];
+
+#ifdef __clang__
+#pragma clang diagnostic push
+#pragma clang diagnostic ignored "-Wdeprecated-declarations" // KeyTranslate
+#endif
+
+            c = KeyTranslate(chr_data, code, &state);
+
+            /* Dead keys are only processed on key-down, so ask
+               to translate those events. When we find a dead key,
+               translating the matching key up event will give
+               us the actual dead character. */
+
+            if (state != 0)
+                c = KeyTranslate(chr_data, code | 128, &state2);
+
+#ifdef __clang__
+#pragma clang diagnostic pop
+#endif
+
+            /* Characters seem to be in MacRoman encoding. */
+
+            if (c != 0 && c != 0x0010) {
+                k[j] = ucs2keysym(macroman2ucs(c & 255));
+
+                if (state != 0) k[j] = make_dead_key(k[j]);
+            }
+        }
+#endif
         }
 
         if (k[3] == k[2]) k[3] = NoSymbol;
diff --git a/hw/xquartz/quartzRandR.c b/hw/xquartz/quartzRandR.c
index 3ecc0e771..cb470fa8e 100644
--- a/hw/xquartz/quartzRandR.c
+++ b/hw/xquartz/quartzRandR.c
@@ -35,12 +35,15 @@
 #include <dix-config.h>
 #endif
 
+#include "quartzCommon.h"
 #include "quartzRandR.h"
 #include "quartz.h"
 #include "darwin.h"
 
 #include "X11Application.h"
 
+#include <AvailabilityMacros.h>
+
 #include <X11/extensions/randr.h>
 #include <randrstr.h>
 #include <IOKit/graphics/IOGraphicsTypes.h>
@@ -63,6 +66,154 @@ static Bool ignore_next_fake_mode_update = FALSE;
 typedef int (*QuartzModeCallback)
     (ScreenPtr, QuartzModeInfoPtr, void *);
 
+#if MAC_OS_X_VERSION_MIN_REQUIRED < 1060
+
+static long
+getDictLong(CFDictionaryRef dictRef, CFStringRef key)
+{
+    long value;
+
+    CFNumberRef numRef = (CFNumberRef)CFDictionaryGetValue(dictRef, key);
+    if (!numRef)
+        return 0;
+
+    if (!CFNumberGetValue(numRef, kCFNumberLongType, &value))
+        return 0;
+    return value;
+}
+
+static double
+getDictDouble(CFDictionaryRef dictRef, CFStringRef key)
+{
+    double value;
+
+    CFNumberRef numRef = (CFNumberRef)CFDictionaryGetValue(dictRef, key);
+    if (!numRef)
+        return 0.0;
+
+    if (!CFNumberGetValue(numRef, kCFNumberDoubleType, &value))
+        return 0.0;
+    return value;
+}
+
+static void
+QuartzRandRGetModeInfo(CFDictionaryRef modeRef,
+                       QuartzModeInfoPtr pMode)
+{
+    pMode->width = (size_t)getDictLong(modeRef, kCGDisplayWidth);
+    pMode->height = (size_t)getDictLong(modeRef, kCGDisplayHeight);
+    pMode->refresh =
+        (int)(getDictDouble(modeRef, kCGDisplayRefreshRate) + 0.5);
+    if (pMode->refresh == 0)
+        pMode->refresh = DEFAULT_REFRESH;
+    pMode->ref = NULL;
+    pMode->pSize = NULL;
+}
+
+static Bool
+QuartzRandRCopyCurrentModeInfo(CGDirectDisplayID screenId,
+                               QuartzModeInfoPtr pMode)
+{
+    CFDictionaryRef curModeRef = CGDisplayCurrentMode(screenId);
+    if (!curModeRef)
+        return FALSE;
+
+    QuartzRandRGetModeInfo(curModeRef, pMode);
+    pMode->ref = (void *)curModeRef;
+    CFRetain(pMode->ref);
+    return TRUE;
+}
+
+static Bool
+QuartzRandRSetCGMode(CGDirectDisplayID screenId,
+                     QuartzModeInfoPtr pMode)
+{
+    CFDictionaryRef modeRef = (CFDictionaryRef)pMode->ref;
+    return (CGDisplaySwitchToMode(screenId, modeRef) == kCGErrorSuccess);
+}
+
+static Bool
+QuartzRandREnumerateModes(ScreenPtr pScreen,
+                          QuartzModeCallback callback,
+                          void *data)
+{
+    Bool retval = FALSE;
+    QuartzScreenPtr pQuartzScreen = QUARTZ_PRIV(pScreen);
+
+    /* Just an 800x600 fallback if we have no attached heads */
+    if (pQuartzScreen->displayIDs) {
+        CFDictionaryRef curModeRef, modeRef;
+        long curBpp;
+        CFArrayRef modes;
+        QuartzModeInfo modeInfo;
+        int i;
+        CGDirectDisplayID screenId = pQuartzScreen->displayIDs[0];
+
+        curModeRef = CGDisplayCurrentMode(screenId);
+        if (!curModeRef)
+            return FALSE;
+        curBpp = getDictLong(curModeRef, kCGDisplayBitsPerPixel);
+
+        modes = CGDisplayAvailableModes(screenId);
+        if (!modes)
+            return FALSE;
+        for (i = 0; i < CFArrayGetCount(modes); i++) {
+            int cb;
+            modeRef = (CFDictionaryRef)CFArrayGetValueAtIndex(modes, i);
+
+            /* Skip modes that are not usable on the current display or have a
+               different pixel encoding than the current mode. */
+            if (((unsigned long)getDictLong(modeRef, kCGDisplayIOFlags) &
+                 kDisplayModeUsableFlags) != kDisplayModeUsableFlags)
+                continue;
+            if (getDictLong(modeRef, kCGDisplayBitsPerPixel) != curBpp)
+                continue;
+
+            QuartzRandRGetModeInfo(modeRef, &modeInfo);
+            modeInfo.ref = (void *)modeRef;
+            cb = callback(pScreen, &modeInfo, data);
+            if (cb == CALLBACK_CONTINUE)
+                retval = TRUE;
+            else if (cb == CALLBACK_SUCCESS)
+                return TRUE;
+            else if (cb == CALLBACK_ERROR)
+                return FALSE;
+        }
+    }
+
+    switch (callback(pScreen, &pQuartzScreen->rootlessMode, data)) {
+    case CALLBACK_SUCCESS:
+        return TRUE;
+
+    case CALLBACK_ERROR:
+        return FALSE;
+
+    case CALLBACK_CONTINUE:
+        retval = TRUE;
+
+    default:
+        break;
+    }
+
+    switch (callback(pScreen, &pQuartzScreen->fullscreenMode, data)) {
+    case CALLBACK_SUCCESS:
+        return TRUE;
+
+    case CALLBACK_ERROR:
+        return FALSE;
+
+    case CALLBACK_CONTINUE:
+        retval = TRUE;
+
+    default:
+        break;
+    }
+
+    return retval;
+}
+
+#else /* we have the new CG APIs from Snow Leopard */
+
 static void
 QuartzRandRGetModeInfo(CGDisplayModeRef modeRef,
                        QuartzModeInfoPtr pMode)
@@ -199,6 +350,8 @@ QuartzRandREnumerateModes(ScreenPtr pScreen,
     return retval;
 }
 
+#endif  /* Snow Leopard CoreGraphics APIs */
+
 static Bool
 QuartzRandRModesEqual(QuartzModeInfoPtr pMode1,
                       QuartzModeInfoPtr pMode2)
diff --git a/hw/xquartz/quartzStartup.c b/hw/xquartz/quartzStartup.c
index 9137edb66..bb92b6d3c 100644
--- a/hw/xquartz/quartzStartup.c
+++ b/hw/xquartz/quartzStartup.c
@@ -36,6 +36,7 @@
 #include <fcntl.h>
 #include <unistd.h>
 #include <CoreFoundation/CoreFoundation.h>
+#include "quartzCommon.h"
 #include "X11Controller.h"
 #include "darwin.h"
 #include "darwinEvents.h"
@@ -74,9 +75,6 @@ create_thread(void *func, void *arg)
     pthread_attr_init(&attr);
     pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
     pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
-    if (&pthread_attr_set_qos_class_np) {
-        pthread_attr_set_qos_class_np(&attr, QOS_CLASS_USER_INTERACTIVE, 0);
-    }
     pthread_create(&tid, &attr, func, arg);
     pthread_attr_destroy(&attr);
 
diff --git a/hw/xquartz/xpr/appledristr.h b/hw/xquartz/xpr/appledristr.h
index 341d72bb4..71346c428 100644
--- a/hw/xquartz/xpr/appledristr.h
+++ b/hw/xquartz/xpr/appledristr.h
@@ -50,126 +50,126 @@
 typedef struct _AppleDRIQueryVersion {
     CARD8 reqType;               /* always DRIReqCode */
     CARD8 driReqType;            /* always X_DRIQueryVersion */
-    CARD16 length;
+    CARD16 length B16;
 } xAppleDRIQueryVersionReq;
 #define sz_xAppleDRIQueryVersionReq 4
 
 typedef struct {
     BYTE type;                   /* X_Reply */
     BOOL pad1;
-    CARD16 sequenceNumber;
-    CARD32 length;
-    CARD16 majorVersion;         /* major version of DRI protocol */
-    CARD16 minorVersion;         /* minor version of DRI protocol */
-    CARD32 patchVersion;         /* patch version of DRI protocol */
-    CARD32 pad3;
-    CARD32 pad4;
-    CARD32 pad5;
-    CARD32 pad6;
+    CARD16 sequenceNumber B16;
+    CARD32 length B32;
+    CARD16 majorVersion B16;     /* major version of DRI protocol */
+    CARD16 minorVersion B16;     /* minor version of DRI protocol */
+    CARD32 patchVersion B32;     /* patch version of DRI protocol */
+    CARD32 pad3 B32;
+    CARD32 pad4 B32;
+    CARD32 pad5 B32;
+    CARD32 pad6 B32;
 } xAppleDRIQueryVersionReply;
 #define sz_xAppleDRIQueryVersionReply 32
 
 typedef struct _AppleDRIQueryDirectRenderingCapable {
     CARD8 reqType;               /* always DRIReqCode */
     CARD8 driReqType;            /* X_DRIQueryDirectRenderingCapable */
-    CARD16 length;
-    CARD32 screen;
+    CARD16 length B16;
+    CARD32 screen B32;
 } xAppleDRIQueryDirectRenderingCapableReq;
 #define sz_xAppleDRIQueryDirectRenderingCapableReq 8
 
 typedef struct {
     BYTE type;                   /* X_Reply */
     BOOL pad1;
-    CARD16 sequenceNumber;
-    CARD32 length;
+    CARD16 sequenceNumber B16;
+    CARD32 length B32;
     BOOL isCapable;
     BOOL pad2;
     BOOL pad3;
     BOOL pad4;
-    CARD32 pad5;
-    CARD32 pad6;
-    CARD32 pad7;
-    CARD32 pad8;
-    CARD32 pad9;
+    CARD32 pad5 B32;
+    CARD32 pad6 B32;
+    CARD32 pad7 B32;
+    CARD32 pad8 B32;
+    CARD32 pad9 B32;
 } xAppleDRIQueryDirectRenderingCapableReply;
 #define sz_xAppleDRIQueryDirectRenderingCapableReply 32
 
 typedef struct _AppleDRIAuthConnection {
     CARD8 reqType;               /* always DRIReqCode */
     CARD8 driReqType;            /* always X_DRICloseConnection */
-    CARD16 length;
-    CARD32 screen;
-    CARD32 magic;
+    CARD16 length B16;
+    CARD32 screen B32;
+    CARD32 magic B32;
 } xAppleDRIAuthConnectionReq;
 #define sz_xAppleDRIAuthConnectionReq 12
 
 typedef struct {
     BYTE type;
     BOOL pad1;
-    CARD16 sequenceNumber;
-    CARD32 length;
-    CARD32 authenticated;
-    CARD32 pad2;
-    CARD32 pad3;
-    CARD32 pad4;
-    CARD32 pad5;
-    CARD32 pad6;
+    CARD16 sequenceNumber B16;
+    CARD32 length B32;
+    CARD32 authenticated B32;
+    CARD32 pad2 B32;
+    CARD32 pad3 B32;
+    CARD32 pad4 B32;
+    CARD32 pad5 B32;
+    CARD32 pad6 B32;
 } xAppleDRIAuthConnectionReply;
 #define zx_xAppleDRIAuthConnectionReply 32
 
 typedef struct _AppleDRICreateSurface {
     CARD8 reqType;               /* always DRIReqCode */
     CARD8 driReqType;            /* always X_DRICreateSurface */
-    CARD16 length;
-    CARD32 screen;
-    CARD32 drawable;
-    CARD32 client_id;
+    CARD16 length B16;
+    CARD32 screen B32;
+    CARD32 drawable B32;
+    CARD32 client_id B32;
 } xAppleDRICreateSurfaceReq;
 #define sz_xAppleDRICreateSurfaceReq 16
 
 typedef struct {
     BYTE type;                   /* X_Reply */
     BOOL pad1;
-    CARD16 sequenceNumber;
-    CARD32 length;
-    CARD32 key_0;
-    CARD32 key_1;
-    CARD32 uid;
-    CARD32 pad4;
-    CARD32 pad5;
-    CARD32 pad6;
+    CARD16 sequenceNumber B16;
+    CARD32 length B32;
+    CARD32 key_0 B32;
+    CARD32 key_1 B32;
+    CARD32 uid B32;
+    CARD32 pad4 B32;
+    CARD32 pad5 B32;
+    CARD32 pad6 B32;
 } xAppleDRICreateSurfaceReply;
 #define sz_xAppleDRICreateSurfaceReply 32
 
 typedef struct _AppleDRIDestroySurface {
     CARD8 reqType;               /* always DRIReqCode */
     CARD8 driReqType;            /* always X_DRIDestroySurface */
-    CARD16 length;
-    CARD32 screen;
-    CARD32 drawable;
+    CARD16 length B16;
+    CARD32 screen B32;
+    CARD32 drawable B32;
 } xAppleDRIDestroySurfaceReq;
 #define sz_xAppleDRIDestroySurfaceReq 12
 
 typedef struct _AppleDRINotify {
     BYTE type;                   /* always eventBase + event type */
     BYTE kind;
-    CARD16 sequenceNumber;
-    CARD32 time;                 /* time of change */
-    CARD32 pad1;
-    CARD32 arg;
-    CARD32 pad3;
-    CARD32 pad4;
-    CARD32 pad5;
-    CARD32 pad6;
+    CARD16 sequenceNumber B16;
+    CARD32 time B32;             /* time of change */
+    CARD32 pad1 B32;
+    CARD32 arg B32;
+    CARD32 pad3 B32;
+    CARD32 pad4 B32;
+    CARD32 pad5 B32;
+    CARD32 pad6 B32;
 } xAppleDRINotifyEvent;
 #define sz_xAppleDRINotifyEvent 32
 
 typedef struct {
     CARD8 reqType;
     CARD8 driReqType;
-    CARD16 length;
-    CARD32 screen;
-    CARD32 drawable;
+    CARD16 length B16;
+    CARD32 screen B32;
+    CARD32 drawable B32;
     BOOL doubleSwap;
     CARD8 pad1, pad2, pad3;
 } xAppleDRICreateSharedBufferReq;
@@ -179,14 +179,14 @@ typedef struct {
 typedef struct {
     BYTE type;
     BYTE data1;
-    CARD16 sequenceNumber;
-    CARD32 length;
-    CARD32 stringLength;         /* 0 on error */
-    CARD32 width;
-    CARD32 height;
-    CARD32 pad1;
-    CARD32 pad2;
-    CARD32 pad3;
+    CARD16 sequenceNumber B16;
+    CARD32 length B32;
+    CARD32 stringLength B32;     /* 0 on error */
+    CARD32 width B32;
+    CARD32 height B32;
+    CARD32 pad1 B32;
+    CARD32 pad2 B32;
+    CARD32 pad3 B32;
 } xAppleDRICreateSharedBufferReply;
 
 #define sz_xAppleDRICreateSharedBufferReply 32
@@ -194,9 +194,9 @@ typedef struct {
 typedef struct {
     CARD8 reqType;
     CARD8 driReqType;
-    CARD16 length;
-    CARD32 screen;
-    CARD32 drawable;
+    CARD16 length B16;
+    CARD32 screen B32;
+    CARD32 drawable B32;
 } xAppleDRISwapBuffersReq;
 
 #define sz_xAppleDRISwapBuffersReq 12
@@ -204,9 +204,9 @@ typedef struct {
 typedef struct {
     CARD8 reqType;               /*1 */
     CARD8 driReqType;            /*2 */
-    CARD16 length;               /*4 */
-    CARD32 screen;               /*8 */
-    CARD32 drawable;             /*12 */
+    CARD16 length B16;           /*4 */
+    CARD32 screen B32;           /*8 */
+    CARD32 drawable B32;         /*12 */
 } xAppleDRICreatePixmapReq;
 
 #define sz_xAppleDRICreatePixmapReq 12
@@ -214,14 +214,14 @@ typedef struct {
 typedef struct {
     BYTE type;                   /*1 */
     BOOL pad1;                   /*2 */
-    CARD16 sequenceNumber;       /*4 */
-    CARD32 length;               /*8 */
-    CARD32 width;                /*12 */
-    CARD32 height;               /*16 */
-    CARD32 pitch;                /*20 */
-    CARD32 bpp;                  /*24 */
-    CARD32 size;                 /*28 */
-    CARD32 stringLength;         /*32 */
+    CARD16 sequenceNumber B16;   /*4 */
+    CARD32 length B32;           /*8 */
+    CARD32 width B32;            /*12 */
+    CARD32 height B32;           /*16 */
+    CARD32 pitch B32;            /*20 */
+    CARD32 bpp B32;              /*24 */
+    CARD32 size B32;             /*28 */
+    CARD32 stringLength B32;     /*32 */
 } xAppleDRICreatePixmapReply;
 
 #define sz_xAppleDRICreatePixmapReply 32
@@ -229,8 +229,8 @@ typedef struct {
 typedef struct {
     CARD8 reqType;               /*1 */
     CARD8 driReqType;            /*2 */
-    CARD16 length;               /*4 */
-    CARD32 drawable;             /*8 */
+    CARD16 length B16;           /*4 */
+    CARD32 drawable B32;         /*8 */
 } xAppleDRIDestroyPixmapReq;
 
 #define sz_xAppleDRIDestroyPixmapReq 8
diff --git a/hw/xquartz/xpr/dri.c b/hw/xquartz/xpr/dri.c
index 091418e19..67ea6a006 100644
--- a/hw/xquartz/xpr/dri.c
+++ b/hw/xquartz/xpr/dri.c
@@ -69,6 +69,8 @@
 #include "x-hook.h"
 #include "driWrap.h"
 
+#include <AvailabilityMacros.h>
+
 static DevPrivateKeyRec DRIScreenPrivKeyRec;
 #define DRIScreenPrivKey       (&DRIScreenPrivKeyRec)
 static DevPrivateKeyRec DRIWindowPrivKeyRec;
diff --git a/hw/xquartz/xpr/x-list.c b/hw/xquartz/xpr/x-list.c
index 171657686..29543d4e0 100644
--- a/hw/xquartz/xpr/x-list.c
+++ b/hw/xquartz/xpr/x-list.c
@@ -281,8 +281,7 @@ list_sort_1(x_list *lst, int length,
 
     /* Then merge them back together. */
 
-    assert(lst != NULL);
-    assert(mid != NULL);
+    assert(lst != NULL && mid != NULL);
 
     if ((*less)(mid->data, lst->data))
         out = out_head = mid, mid = mid->next;
diff --git a/hw/xquartz/xpr/xprAppleWM.c b/hw/xquartz/xpr/xprAppleWM.c
index 126661766..8c4f5efb8 100644
--- a/hw/xquartz/xpr/xprAppleWM.c
+++ b/hw/xquartz/xpr/xprAppleWM.c
@@ -82,6 +82,7 @@ xprSetWindowLevel(WindowPtr pWin, int level)
     return Success;
 }
 
+#if defined(XPLUGIN_VERSION) && XPLUGIN_VERSION >= 3
 static int
 xprAttachTransient(WindowPtr pWinChild, WindowPtr pWinParent)
 {
@@ -113,6 +114,7 @@ xprAttachTransient(WindowPtr pWinChild, WindowPtr pWinParent)
 
     return Success;
 }
+#endif
 
 static int
 xprFrameDraw(WindowPtr pWin,
@@ -144,8 +146,16 @@ static AppleWMProcsRec xprAppleWMProcs = {
     xp_frame_get_rect,
     xp_frame_hit_test,
     xprFrameDraw,
+#if defined(XPLUGIN_VERSION) && XPLUGIN_VERSION >= 3
     xp_set_dock_proxy,
     xprAttachTransient
+#elif defined(XPLUGIN_VERSION) && XPLUGIN_VERSION >= 2
+    xp_set_dock_proxy,
+    NULL
+#else
+    NULL,
+    NULL
+#endif
 };
 
 void
diff --git a/hw/xquartz/xpr/xprEvent.c b/hw/xquartz/xpr/xprEvent.c
index eb321a52f..398177ca8 100644
--- a/hw/xquartz/xpr/xprEvent.c
+++ b/hw/xquartz/xpr/xprEvent.c
@@ -52,7 +52,9 @@
 #include <sys/uio.h>
 #include <unistd.h>
 
+#ifdef HAVE_LIBDISPATCH
 #include <dispatch/dispatch.h>
+#endif
 
 #include "rootlessWindow.h"
 #include "xprEvent.h"
@@ -74,9 +76,24 @@ QuartzModeEventHandler(int screenNum, XQuartzEvent *e, DeviceIntPtr dev)
 
     case kXquartzBringAllToFront:
         DEBUG_LOG("kXquartzBringAllToFront\n");
-        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
-            xp_window_bring_all_to_front();
-        });
+        /* There's no need to do xp_window_bring_all_to_front on Leopard,
+         * and we don't care about the result, so just do it async.
+         */
+#if defined(HAVE_LIBDISPATCH) && defined(XPLUGIN_VERSION) && XPLUGIN_VERSION >= 6
+#  if defined(XPLUGIN_VERSION_MIN_REQUIRED) && XPLUGIN_VERSION_MIN_REQUIRED < 6
+        if (&xp_window_bring_all_to_front) {
+#  endif
+            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+                xp_window_bring_all_to_front();
+            });
+#  if defined(XPLUGIN_VERSION_MIN_REQUIRED) && XPLUGIN_VERSION_MIN_REQUIRED < 6
+        } else {
+            RootlessOrderAllWindows(e->data[0]);
+        }
+#  endif
+#else
+        RootlessOrderAllWindows(e->data[0]);
+#endif
 
         return TRUE;
 
diff --git a/hw/xquartz/xpr/xprFrame.c b/hw/xquartz/xpr/xprFrame.c
index 57d16d42f..aad375b52 100644
--- a/hw/xquartz/xpr/xprFrame.c
+++ b/hw/xquartz/xpr/xprFrame.c
@@ -43,7 +43,15 @@
 #include "windowstr.h"
 #include "quartz.h"
 
+#ifdef HAVE_LIBDISPATCH
 #include <dispatch/dispatch.h>
+#else
+#include <pthread.h>
+#endif
+
+#ifdef DEBUG_XP_LOCK_WINDOW
+#include <execinfo.h>
+#endif
 
 #define DEFINE_ATOM_HELPER(func, atom_name)                      \
     static Atom func(void) {                                       \
@@ -62,7 +70,11 @@ DEFINE_ATOM_HELPER(xa_native_window_id, "_NATIVE_WINDOW_ID")
 static x_hash_table * window_hash;
 
 /* Need to guard window_hash since xprIsX11Window can be called from any thread. */
+#ifdef HAVE_LIBDISPATCH
 static dispatch_queue_t window_hash_serial_q;
+#else
+static pthread_rwlock_t window_hash_rwlock;
+#endif
 
 /* Prototypes for static functions */
 static Bool
@@ -197,9 +209,15 @@ xprCreateFrame(RootlessWindowPtr pFrame, ScreenPtr pScreen,
         return FALSE;
     }
 
+#ifdef HAVE_LIBDISPATCH
     dispatch_async(window_hash_serial_q, ^ {
                        x_hash_table_insert(window_hash, pFrame->wid, pFrame);
                    });
+#else
+    pthread_rwlock_wrlock(&window_hash_rwlock);
+    x_hash_table_insert(window_hash, pFrame->wid, pFrame);
+    pthread_rwlock_unlock(&window_hash_rwlock);
+#endif
 
     xprSetNativeProperty(pFrame);
 
@@ -214,9 +232,15 @@ xprDestroyFrame(RootlessFrameID wid)
 {
     xp_error err;
 
+#ifdef HAVE_LIBDISPATCH
     dispatch_async(window_hash_serial_q, ^ {
                        x_hash_table_remove(window_hash, wid);
                    });
+#else
+    pthread_rwlock_wrlock(&window_hash_rwlock);
+    x_hash_table_remove(window_hash, wid);
+    pthread_rwlock_unlock(&window_hash_rwlock);
+#endif
 
     err = xp_destroy_window(x_cvt_vptr_to_uint(wid));
     if (err != Success)
@@ -269,7 +293,9 @@ xprRestackFrame(RootlessFrameID wid, RootlessFrameID nextWid)
 {
     xp_window_changes wc;
     unsigned int mask = XP_STACKING;
+#ifdef HAVE_LIBDISPATCH
     __block
+#endif
     RootlessWindowRec * winRec;
 
     /* Stack frame below nextWid it if it exists, or raise
@@ -284,9 +310,15 @@ xprRestackFrame(RootlessFrameID wid, RootlessFrameID nextWid)
         wc.sibling = x_cvt_vptr_to_uint(nextWid);
     }
 
+#ifdef HAVE_LIBDISPATCH
     dispatch_sync(window_hash_serial_q, ^ {
                       winRec = x_hash_table_lookup(window_hash, wid, NULL);
                   });
+#else
+    pthread_rwlock_rdlock(&window_hash_rwlock);
+    winRec = x_hash_table_lookup(window_hash, wid, NULL);
+    pthread_rwlock_unlock(&window_hash_rwlock);
+#endif
 
     if (winRec) {
         if (XQuartzIsRootless)
@@ -349,8 +381,15 @@ xprStartDrawing(RootlessFrameID wid, char **pixelData, int *bytesPerRow)
     xp_error err;
 
 #ifdef DEBUG_XP_LOCK_WINDOW
+    void* callstack[128];
+    int i, frames = backtrace(callstack, 128);
+    char** strs = backtrace_symbols(callstack, frames);
+
     ErrorF("=== LOCK %d ===\n", (int)x_cvt_vptr_to_uint(wid));
-    xorg_backtrace();
+    for (i = 0; i < frames; ++i) {
+        ErrorF("    %s\n", strs[i]);
+    }
+    free(strs);
 #endif
 
     err = xp_lock_window(x_cvt_vptr_to_uint(
@@ -360,10 +399,6 @@ xprStartDrawing(RootlessFrameID wid, char **pixelData, int *bytesPerRow)
                    (int)x_cvt_vptr_to_uint(
                        wid), (int)err);
 
-#ifdef DEBUG_XP_LOCK_WINDOW
-    ErrorF("  bits: %p\n", *data);
-#endif
-
     *pixelData = data[0];
     *bytesPerRow = rowbytes[0];
 }
@@ -377,8 +412,15 @@ xprStopDrawing(RootlessFrameID wid, Bool flush)
     xp_error err;
 
 #ifdef DEBUG_XP_LOCK_WINDOW
+    void* callstack[128];
+    int i, frames = backtrace(callstack, 128);
+    char** strs = backtrace_symbols(callstack, frames);
+
     ErrorF("=== UNLOCK %d ===\n", (int)x_cvt_vptr_to_uint(wid));
-    xorg_backtrace();
+    for (i = 0; i < frames; ++i) {
+        ErrorF("    %s\n", strs[i]);
+    }
+    free(strs);
 #endif
 
     err = xp_unlock_window(x_cvt_vptr_to_uint(wid), flush);
@@ -477,9 +519,13 @@ xprInit(ScreenPtr pScreen)
     rootless_CopyWindow_threshold = xp_scroll_area_threshold;
 
     assert((window_hash = x_hash_table_new(NULL, NULL, NULL, NULL)));
+#ifdef HAVE_LIBDISPATCH
     assert((window_hash_serial_q =
                 dispatch_queue_create(BUNDLE_ID_PREFIX ".X11.xpr_window_hash",
                                       NULL)));
+#else
+    assert(0 == pthread_rwlock_init(&window_hash_rwlock, NULL));
+#endif
 
     return TRUE;
 }
@@ -491,12 +537,19 @@ xprInit(ScreenPtr pScreen)
 WindowPtr
 xprGetXWindow(xp_window_id wid)
 {
+#ifdef HAVE_LIBDISPATCH
     RootlessWindowRec *winRec __block;
     dispatch_sync(window_hash_serial_q, ^ {
                       winRec =
                           x_hash_table_lookup(window_hash,
                                               x_cvt_uint_to_vptr(wid), NULL);
                   });
+#else
+    RootlessWindowRec *winRec;
+    pthread_rwlock_rdlock(&window_hash_rwlock);
+    winRec = x_hash_table_lookup(window_hash, x_cvt_uint_to_vptr(wid), NULL);
+    pthread_rwlock_unlock(&window_hash_rwlock);
+#endif
 
     return winRec != NULL ? winRec->win : NULL;
 }
